Index: src/sys/dev/usb/usb_subr.c
===================================================================
RCS file: /bracket/repo/src/sys/dev/usb/usb_subr.c,v
retrieving revision 1.192
diff -u -r1.192 usb_subr.c
--- src/sys/dev/usb/usb_subr.c	7 Sep 2013 16:39:15 -0000	1.192
+++ src/sys/dev/usb/usb_subr.c	14 Sep 2013 10:28:07 -0000
@@ -611,10 +611,8 @@
 
 	/* Get the short descriptor. */
 	err = usbd_get_config_desc(dev, index, &cd);
-	if (err) {
-		DPRINTF(("usbd_set_config_index: get_config_desc=%d\n", err));
+	if (err)
 		return (err);
-	}
 	len = UGETW(cd.wTotalLength);
 	cdp = malloc(len, M_USB, M_NOWAIT);
 	if (cdp == NULL)
@@ -627,10 +625,9 @@
 			break;
 		usbd_delay_ms(dev, 200);
 	}
-	if (err) {
-		DPRINTF(("usbd_set_config_index: get_desc=%d\n", err));
+	if (err)
 		goto bad;
-	}
+
 	if (cdp->bDescriptorType != UDESC_CONFIG) {
 		DPRINTFN(-1,("usbd_set_config_index: bad desc %d\n",
 			     cdp->bDescriptorType));
@@ -1059,34 +1056,6 @@
 }
 
 /*
- * Get the first 8 bytes of the device descriptor.
- * Do as Windows does: try to read 64 bytes -- there are devices which
- * recognize the initial descriptor fetch (before the control endpoint's
- * MaxPacketSize is known by the host) by exactly this length.
- */
-static usbd_status
-usbd_get_initial_ddesc(usbd_device_handle dev, usb_device_descriptor_t *desc)
-{
-	usb_device_request_t req;
-	char buf[64];
-	int res, actlen;
-
-	req.bmRequestType = UT_READ_DEVICE;
-	req.bRequest = UR_GET_DESCRIPTOR;
-	USETW2(req.wValue, UDESC_DEVICE, 0);
-	USETW(req.wIndex, 0);
-	USETW(req.wLength, 64);
-	res = usbd_do_request_flags(dev, &req, buf, USBD_SHORT_XFER_OK,
-		&actlen, USBD_DEFAULT_TIMEOUT);
-	if (res)
-		return res;
-	if (actlen < 8)
-		return USBD_SHORT_XFER;
-	memcpy(desc, buf, 8);
-	return USBD_NORMAL_COMPLETION;
-}
-
-/*
  * Called when a new device has been put in the powered state,
  * but not yet in the addressed state.
  * Get initial descriptor, set the address, get full descriptor,
@@ -1186,7 +1155,11 @@
 	/* Try a few times in case the device is slow (i.e. outside specs.) */
 	for (i = 0; i < 10; i++) {
 		/* Get the first 8 bytes of the device descriptor. */
-		err = usbd_get_initial_ddesc(dev, dd);
+		err = usbd_get_desc(dev, UDESC_DEVICE, 0, 
+			(speed == USB_SPEED_HIGH) ? USB_DEVICE_DESCRIPTOR_SIZE
+						  : USB_MAX_IPACKET,
+			 dd);
+
 		if (!err)
 			break;
 		usbd_delay_ms(dev, 200);
